#include <stdio.h>
#include <stdlib.h>
#include "align.h"

void mul_score()
{
  int i, j;

  for(i=0;i<('Z' + 1 - 'A');i++)
    for (j=0;j<('Z' + 1 - 'A');j++) {
      score_table[i][j] *= gap_denominator;
    }
}

void div_score()
{
  int i, j;

  for(i=0;i<('Z' + 1 - 'A');i++)
    for (j=0;j<('Z' + 1 - 'A');j++) {
      score_table[i][j] /= gap_denominator;
    }
}

void init_scores()
{
int i,j;

  for(i=0;i<(('Z' + 1 - 'A')+2);i++)
    for (j=0;j<(('Z' + 1 - 'A')+2);j++) {
      score_table[i][j] = 0;
      score_table1[i][j] = 0;
      score_table2[i][j] = 0;
      score_table3[i][j] = 0;
    }
}

int normalize_score()
{
  int i,j;
  int d;

  d = max_score;

  for(i=0;(i<(('Z' + 1 - 'A')+2));i++) {
    for(j=i;j<(('Z' + 1 - 'A')+2);j++) {
      if (d == 0) d = abs(score_table[i][j]);
      else d = gcd(d, score_table[i][j]);
      if (d == 1) return 1;
    }
  }
  for(i=0;(i<(('Z' + 1 - 'A')+2));i++) {
    for(j=0;j<(('Z' + 1 - 'A')+2);j++) {
      score_table[i][j] /= d;
    }
  }
  max_score /= d;
  internal_gap_penalty /= d;
  external_gap_penalty /= d;
  return d;
}

int weighted_score(alignment_t *al_p, int **ws)
{
  int i, j, k;
  int score;
  int pairscore;
  char x,y;

  score = 0;
  for(i=1;i<al_p->dim; i++) {
    for(j=0;j<i;j++) {
      pairscore = 0;
      for(k=0;k<al_p->seq[0].len;k++) {
	if((x = al_p->seq[i].str[k]) < INTERNAL_GAP_CHAR) {
	  if((y = al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += score_table[(x) - 'A'][(y) - 'A'];
	  } else if((y) == INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty;
	  } else {
	    pairscore += external_gap_penalty;
	  }
	} else if ((x) == INTERNAL_GAP_CHAR) {
	  if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty;
	  }
	} else if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	  pairscore += external_gap_penalty;
	}
      }
      score += (pairscore * ws[i][j]);
    }
  }
  return score;
}

int weighted_score_gd(alignment_t *al_p, int **ws)
{
  int i, j, k;
  int score;
  int pairscore;
  char x,y;

  score = 0;
  for(i=1;i<al_p->dim; i++) {
    for(j=0;j<i;j++) {
      pairscore = 0;
      for(k=0;k<al_p->seq[0].len;k++) {
	if((x = al_p->seq[i].str[k]) < INTERNAL_GAP_CHAR) {
	  if((y = al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += score_table[(x) - 'A'][(y) - 'A'];
	  } else if((y) == INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty;
	  } else {
	    pairscore += external_gap_penalty;
	  }
	} else if ((x) == INTERNAL_GAP_CHAR) {
	  if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty;
	  }
	} else if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	  pairscore += external_gap_penalty;
	}
      }
      score += (pairscore * ws[i][j] * gap_denominator);
    }
  }
  return score;
}

int score_slope(alignment_t *al_p)
{
  int i, j, k;
  int score;
  int pairscore;
  char x,y;

  score = 0;
  for(i=1;i<al_p->dim; i++) {
    for(j=0;j<i;j++) {
      pairscore = 0;
      for(k=0;k<al_p->seq[0].len;k++) {
	if((x = al_p->seq[i].str[k]) < INTERNAL_GAP_CHAR) {
	  if((y = al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += score_table3[(x) - 'A'][(y) - 'A'];
	  } else if((y) == INTERNAL_GAP_CHAR) {
	    pairscore += (internal_gap_penalty2 - internal_gap_penalty1);
	  } else {
	    pairscore += (external_gap_penalty2 - external_gap_penalty1);
	  }
	} else if ((x) == INTERNAL_GAP_CHAR) {
	  if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += (internal_gap_penalty2 - internal_gap_penalty1);
	  }
	} else if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	  pairscore += (external_gap_penalty2 - external_gap_penalty1);
	}
      }
      score += (pairscore * weights[i][j]);
    }
  }
  return score;
}

int another_score1(alignment_t *al_p)
{
  int i, j, k;
  int score;
  int pairscore;
  char x,y;

  score = 0;
  for(i=1;i<al_p->dim; i++) {
    for(j=0;j<i;j++) {
      pairscore = 0;
      for(k=0;k<al_p->seq[0].len;k++) {
	if((x = al_p->seq[i].str[k]) < INTERNAL_GAP_CHAR) {
	  if((y = al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += score_table1[(x) - 'A'][(y) - 'A'];
	  } else if((y) == INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty1;
	  } else {
	    pairscore += external_gap_penalty1;
	  }
	} else if ((x) == INTERNAL_GAP_CHAR) {
	  if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty1;
	  }
	} else if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	  pairscore += external_gap_penalty1;
	}
      }
      score += (pairscore * weights[i][j]);
    }
  }
  return score;
}

int another_score2(alignment_t *al_p)
{
  int i, j, k;
  int score;
  int pairscore;
  char x,y;

  score = 0;
  for(i=1;i<al_p->dim; i++) {
    for(j=0;j<i;j++) {
      pairscore = 0;
      for(k=0;k<al_p->seq[0].len;k++) {
	if((x = al_p->seq[i].str[k]) < INTERNAL_GAP_CHAR) {
	  if((y = al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += score_table2[(x) - 'A'][(y) - 'A'];
	  } else if((y) == INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty2;
	  } else {
	    pairscore += external_gap_penalty2;
	  }
	} else if ((x) == INTERNAL_GAP_CHAR) {
	  if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	    pairscore += internal_gap_penalty2;
	  }
	} else if((al_p->seq[j].str[k]) < INTERNAL_GAP_CHAR) {
	  pairscore += external_gap_penalty2;
	}
      }
      score += (pairscore * weights[i][j]);
    }
  }
  return score;
}
